
public class DoubleHashing {
	final static int N = 65537;
	Matrix[] tab;
	
	DoubleHashing() {
		tab = new Matrix[N];
	}
	
	// returns x mod N
	static int modulo(int x) {
		int result = x % N;
		return (result < 0 ? result+N : result);
	}
	
	// add m in the hash table
	void add(Matrix m) {
		int pos = modulo(m.hash1());
		int offset = modulo(m.hash2());
		offset = (offset == 0 ? 1 : offset);
		while (tab[pos] != null) 
			pos = modulo(pos + offset);
		tab[pos] = m;
	}
	
	// search m in the hash table
	 boolean find(Matrix m) {
			int pos = modulo(m.hash1());
			int offset = modulo(m.hash2());
			offset = (offset == 0 ? 1 : offset);
			while (tab[pos] != null) {
				if (tab[pos].equals(m))
					return true;
				pos = modulo(pos + offset);
			}
			return false;
	}
	
	// test
	public static void main(String[] args) {
		// tests of modulo
		System.out.println(modulo(-65536));
		System.out.println(modulo(1));
		System.out.println(modulo(65538));
		// creates a double hash table
		DoubleHashing dh = new DoubleHashing();
		// tests insertion
		for (int i = 0; i < 100; i++)
			dh.add(Matrix.randomMatrix(4, 4, 2));
		/*
		int count = 0;
		for (int i = 0; i < N; i++)
			if (dh.tab[i] != null)
				count++;
		System.out.println(count);
		*/
		// tests find
		Matrix m = Matrix.randomMatrix(4, 4, 2);
		dh.add(m);
		System.out.println(dh.find(m));
		System.out.println(dh.find(Matrix.randomMatrix(4, 4, 2)));
	}
}
