import java.util.LinkedList;

public class Duplicates {
	
	// tests if a list of matrices contains a duplicate
	static boolean containsDuplicate(LinkedList<Matrix> l) {
		DoubleHashing dh = new DoubleHashing();
		for (Matrix m : l) {
			if (dh.find(m))
				return true;
			dh.add(m);
		}
		return false;
	}
	
	// birthday paradox for QR codes
	public static void main(String[] args) {
		int count1 = 0, count2 = 0;
		for (int i = 0; i < 100; i++) {
			LinkedList<Matrix> l1 = new LinkedList<Matrix>();
			for (int j1 = 0; j1 < 200; j1++)
				l1.add(Matrix.randomMatrix(4, 4, 2));
			if (containsDuplicate(l1))
				count1++;
			LinkedList<Matrix> l2 = new LinkedList<Matrix>();
			for (int j2 = 0; j2 < 400; j2++)
				l2.add(Matrix.randomMatrix(4, 4, 2));
			if (containsDuplicate(l2))
				count2++;
		}
		System.out.println(count1 + " " + count2);
	}
}
