public class Matrix {
	int[][] mat;

	Matrix(int[][] mat) {
		this.mat = mat;
	}

	int hash1() {
		int code = 0;
		for (int i = 0; i < mat.length; i++) {
			for (int j = 0; j < mat[i].length; j++)
				code = code * 13 + mat[i][j];
			code *= 17;
		}
		return code;
	}

	int hash2() {
		int code = 0;
		for (int i = 0; i < mat.length; i++) {
			for (int j = 0; j < mat[i].length; j++)
				code = code * 11 + mat[i][j];
			code *= 19;
		}
		return code;
	}

	public boolean equals(Object o) {
		Matrix m = (Matrix) o;
		if (mat.length != m.mat.length)
			return false;
		for (int i = 0; i < mat.length; i++) {
			if (mat[i].length != m.mat[i].length)
				return false;
			for (int j = 0; j < mat[i].length; j++)
				if (mat[i][j] != m.mat[i][j])
					return false;
		}
		return true;
	}
	
	// returns a random n x m matrix each of whose coefficient is random amongs 0 .. k-1
	static Matrix randomMatrix(int n, int m, int k) {
		int[][] mat = new int[n][m];
		for (int i = 0; i < mat.length; i++)
			for (int j = 0; j < mat[i].length; j++)
				mat[i][j] = (int) (Math.random()*k);
		return new Matrix(mat);
	}
	
	// test
	public static void main(String[] args) {
		for (int i = 0; i < 100; i++) {
			Matrix m = randomMatrix(5,5,2);
			System.out.println(m.hash1() + "  " + m.hash2());
		}
	}
}
